#
# spec file for package ulimit (Version 1.1)
#
# Copyright (c) 2005 SUSE LINUX Products GmbH, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://www.suse.de/feedback/
#

# norootforbuild
# neededforbuild  

BuildRequires: aaa_base acl attr bash bind-utils bison bzip2 coreutils cpio cpp cracklib cvs cyrus-sasl db devs diffutils e2fsprogs file filesystem fillup findutils flex gawk gdbm-devel glibc glibc-devel glibc-locale gpm grep groff gzip info insserv kbd less libacl libattr libgcc libselinux libstdc++ libxcrypt m4 make man mktemp module-init-tools ncurses ncurses-devel net-tools netcfg openldap2-client openssl pam pam-modules patch permissions popt procinfo procps psmisc pwdutils rcs readline sed strace syslogd sysvinit tar tcpd texinfo timezone unzip util-linux vim zlib zlib-devel autoconf automake binutils gcc gdbm gettext libtool perl rpm

Name:         ulimit
License:      Artistic License
Group:        System/Base
Autoreqprov:  on
Summary:      Set per-process limits (ulimits)
Version:      1.1
Release:      127.4
Source:       %{name}-%{version}.tar.gz
Patch:        ulimit-evalexec.diff
Patch2:       ulimit-kernel26.diff
Patch3:       ulimit-nolocklimit.diff
BuildRoot:    %{_tmppath}/%{name}-%{version}-build
BuildArch:	noarch
%if %suse_version > 800
PreReq:       %fillup_prereq
%endif

%description
The file /etc/initscript is used by init to execute the commands in
/etc/inittab. As any process it started from init, it is a convenient
place to adjust per process limits (ulimits).

The script provided here does set limits on the memory usage per
process (amongst setting other limits) and thus prevents that a single
process that leaks memory can cause your system to run out of memory
and provoke the system to crawl (trash on the swap partition) before it
rescues itself by killing processes (but unfortunately does not always
hit the right process with the first try). The script sets the limits
in percent of available memory, thus the defaults may match a large
range of systems.

Configuration is done in file /etc/sysconfig/ulimit.



Authors:
--------
    Kurt Garloff <garloff@suse.de>

%prep
%setup -n ulimit
%patch -p1
%patch2 -p1
%patch3 -p1

%build
# nothing to be done

%install
install -d $RPM_BUILD_ROOT/etc
install initscript $RPM_BUILD_ROOT/etc/initscript
install -d $RPM_BUILD_ROOT/var/adm/fillup-templates
install sysconfig.ulimit $RPM_BUILD_ROOT/var/adm/fillup-templates/

%files
%defattr(-,root,root)
%config /etc/initscript
/var/adm/fillup-templates/sysconfig.ulimit

%post
%{fillup_only ulimit}

%clean
if test ! -z "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != "/"; then rm -rf $RPM_BUILD_ROOT; fi
rm -rf $RPM_BUILD_DIR/ulimit

%changelog -n ulimit
* Fri Apr 01 2005 - garloff@suse.de
- Make script work with both pre- and post 2.6.8 kernels. (#74085)
* Sat Mar 26 2005 - garloff@suse.de
- Adapt order of applying soft vs hard limits to peculiar 2.6
  requirements for all limits. (#74085, #49323, #60650)
* Sat Mar 26 2005 - garloff@suse.de
- Use eval exec "$4" to invoke binary (#74221, #60650).
* Fri Sep 24 2004 - garloff@suse.de
- Don't set a limit for locked mem by default. Triggers warning
  with latest 2.6.9-rc kernels. (#SUSE45650)
- Document that the stack limit should not be set either, as
  NPTL uses this a stack size for multithreade programs.
* Sun Mar 28 2004 - garloff@suse.de
- Kernel 2.6 needs the soft limits before the hard ones. (#SUSE34323)
* Fri Feb 06 2004 - hmacht@suse.de
- building as non root (#norootforbuild)
* Fri Aug 15 2003 - garloff@suse.de
- Remove left-over debug output to /tmp
- Specify Command: killall mingetty to restart some service using
  the new limits. (We miss sshd and xdm.)
* Tue Aug 12 2003 - garloff@suse.de
- Update to 1.1: Collect arguments first to reduce the number of
  calls to ulimit. (Performance improvement.)
* Fri Aug 08 2003 - garloff@suse.de
- Creation of SuSE package.
